=== debian/changelog ===
vg (1.25.0+ds-3build1) groovy; urgency=medium

  * No change rebuild against new libffi8ubuntu1 ABI.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 24 Aug 2020 20:12:48 +0100

vg (1.25.0+ds-3) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Fix build by not linking anymore libebl.a (Closes: #966417)

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 31 Jul 2020 15:09:46 +0200

vg (1.25.0+ds-2) unstable; urgency=medium

  * Restrict architectures to build for. Closes: #964039.

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 14 Jul 2020 15:15:28 +0200

vg (1.25.0+ds-1) unstable; urgency=medium

  * New upstream version
  * debhelper-compat 13 (routine-update)

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 25 Jun 2020 15:10:24 +0200

vg (1.24.0+ds-1) unstable; urgency=medium

  * Build all SIMD variants on i386, even those "higher" than ssse3
  * New upstream version
  * Refreshed patches

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sat, 23 May 2020 19:38:48 +0200

vg (1.23.0+ds-2) unstable; urgency=medium

  * Switch to libsimde-dev from code copy
  * Add Repository{,-Browse} to debian/upstream/metadata

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Mon, 20 Apr 2020 12:22:22 +0200

vg (1.23.0+ds-1) unstable; urgency=medium

  * New upstream version
  * Respect DEB_BUILD_OPTIONS in override_dh_auto_test target (routine-
    update)
  * Rules-Requires-Root: no (routine-update)

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Mon, 30 Mar 2020 22:33:32 +0200
